from emod_api import schema_to_class as s2c
import emod_api.interventions.common as common
import emod_api.interventions.utils as utils
from emodpy_tbhiv.interventions import purge_campaign_event

def SmearDiagnostic(
        camp,
        trigger_treatment_list,
        base_sensitivity_smearpos=1.0,
        base_sensitivity_smearneg=1.0,
        pos_event= 'TestPositiveOnSmear',
        treatment_fraction=1,
        start_day=0,
        duration=-1,
        property_restrictions_list=[],
        nodeIDs=[],
        black_period=0,
        black_trigger='Blackout',
        event_name='TB Diagnosis Smear Simple'):
    """
    SmearDiagnostic
    :param TBD
    Note start_day is initialized as 1, recommend that this be aligned with the start of the simulation
    """
    schema_path = camp.schema_path
    intervention = s2c.get_class_with_defaults( "SmearDiagnostic", schema_path )
    intervention.Base_Sensitivity = base_sensitivity_smearpos
    intervention.Base_Specificity = base_sensitivity_smearneg
    intervention.Treatment_Fraction = treatment_fraction
    #intervention.Days_To_Diagnosis = 0
    intervention.Event_Or_Config = 'Event'
    intervention.Positive_Diagnosis_Event = camp.get_send_trigger( pos_event )

    event = common.TriggeredCampaignEvent( camp, start_day,event_name, utils.do_nodes( camp.schema_path, nodeIDs ), trigger_treatment_list, [ intervention ], Duration=duration, Property_Restrictions=property_restrictions_list )
    purge_campaign_event( event )

    return event

def new_intervention_as_file( camp, filename="smear_diag.json" ):
    camp.add( SmearDiagnostic( camp, trigger_treatment_list=[ "Births" ] ) )
    camp.save( filename )
    return filename

